﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace XamDataChartMarker
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            LiveViewDataPoint Trades = new LiveViewDataPoint();

            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now, Price = 25.68 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(1), Price = 15.68});
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(2), Price = 45.56});
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(3), Price = 125.68});

            this.DataContext = Trades;   
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            (this.DataContext as LiveViewDataPoint).PointLabelsIsVisible = !(this.DataContext as LiveViewDataPoint).PointLabelsIsVisible;
        }
    }

    public class LiveViewDataPoint : ObservableCollection<LiveViewDataPoint>, INotifyPropertyChanged
    {
        public DateTime Date { get; set; }
        public double Price { get; set; }
        private bool pointLabelsIsVisible { get; set; }

        public LiveViewDataPoint()
        {
            PointLabelsIsVisible = true;
        }

        public bool PointLabelsIsVisible
        {
            get { return this.pointLabelsIsVisible; }

            set
            {
                if (value != this.pointLabelsIsVisible)
                {
                    this.pointLabelsIsVisible = value;
                    NotifyPropertyChanged("PointLabelsIsVisible");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

    }
}